"""
Module showing off how to create a button.

In this demo, we create a button as a subclass of GLabel.  We add some attributes and
make it switch color when we click on it

Author: Walker M. White
Date: November 30, 2020
"""
from game2d import *

### Constants ###

# The initial window width
GAME_WIDTH  = 640
# The initial window height
GAME_HEIGHT = 480


class App(GameApp):
    """
    The basic app for processing a button click
    """
    # Attribute _button: The button to click on
    # Invariant: _button is a GButton object
    #
    # Attribute _last: The previous touch position
    # Invariant: _last is None or a 2-element tuple

    def start(self):
        """
        Initialize the button
        """
        pass #Implement me

    def update(self,dt):
        """
        Detect a button press

        Parameter dt: The time since the last animation frame
        Precondition: dt is a float
        """
        pass #Implement me

    def draw(self):
        """
        Draw the button
        """
        pass #Implement me


class GButton(GLabel):
    """
    A button that changes color when clicked

    The button uses Times New Roman as its font and alternates between
    green and red.
    """
    # Attribute _pressed: Whether the button is pressed
    # Invariant: _pressed is a bool; if up the color is green; if down the color is red

    pass # Implement me


# Script Code
if __name__ == '__main__':
    App(width=GAME_WIDTH,height=GAME_HEIGHT).run()
